#include <arduino.h>
#include <avr/io.h>
#include "sseg.h"


byte gSegmentDatas[39] =
{
//     abcdefg
	 0b0000001, // 0
	 0b1001111, // 1
	 0b0010010, // 2
	 0b0000110, // 3
	 0b1001100, // 4
	 0b0100100, // 5
	 0b0100000, // 6
	 0b0001101, // 7
	 0b0000000, // 8
	 0b0000100, // 9
	 0b1111111, // NONE
	 0b1111110, // MINUS
	 0b0001000, // A
	 0b1100000, // b
	 0b0110001, // C
	 0b1000010, // d
	 0b0110000, // E
	 0b0111000, // F
	 0b0110001, // G
	 0b1001000, // H
	 0b1001111, // I
	 0b1000111, // J
	 0b1111000, // k
	 0b1110001, // L
	 0b0001001, // m
	 0b1101010, // n
	 0b1100010, // o
	 0b0011000, // P
	 0b0001100, // q
	 0b1111010, // r
	 0b0100110, // s
	 0b0110101, // T
	 0b1000001, // U
	 0b1100011, // v
	 0b1011011, // w
	 0b1001000, // X
	 0b1001100, // y
	 0b0110110, // z
	 0b1111110  // Special(Div)
};


SSEG::SSEG(void)
{
	number_displayed = 0;
	current_digit = 0;
	
	SetInit();
}

void SSEG::SetInit()
{
	PORTD |= _BV(4);
	PORTD |= _BV(5);
	PORTD |= _BV(6);
	PORTD |= _BV(7);

	pinMode(4, OUTPUT);
	pinMode(5, OUTPUT);
	pinMode(6, OUTPUT);
	pinMode(7, OUTPUT);	
	pinMode(10, OUTPUT);
	pinMode(9, OUTPUT);
	pinMode(A1, OUTPUT);
	pinMode(A3, OUTPUT);
	pinMode(A2, OUTPUT);
	pinMode(8, OUTPUT);
	pinMode(A0, OUTPUT);
	
}

void SSEG::DisplayClear()
{
	Display(SSEG_NONE);
}

void SSEG::Display(int inWord)
{

	//高速化のため、0-9と-は、直接ポート操作する
	switch(inWord)
	{
		case SSEG_0:
			//0b0000001, // 0
			PORTC |=  _BV(0);//1
			PORTB &= ~_BV(0);//0
			PORTC &= ~_BV(2);//0			
			PORTC &= ~_BV(3);//0			
			PORTC &= ~_BV(1);//0			
			PORTB &= ~_BV(1);//0
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_1:
			//0b1001111, // 1
			PORTC |=  _BV(0);//1
			PORTB |=  _BV(0);//1
			PORTC |=  _BV(2);//1			
			PORTC |=  _BV(3);//1			
			PORTC &= ~_BV(1);//0			
			PORTB &= ~_BV(1);//0
			PORTB |=  _BV(2);//1
			break;
		case SSEG_2:
			//0b0010010, // 2
			PORTC &= ~_BV(0);//0
			PORTB |= _BV(0);//1
			PORTC &= ~_BV(2);//0
			PORTC &= ~_BV(3);//0
			PORTC |= _BV(1);//1
			PORTB &= ~_BV(1);//0
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_3:
			//0b0000110, // 3
			PORTC &= ~_BV(0);//0
			PORTB |= _BV(0);//1
			PORTC |= _BV(2);//1
			PORTC &= ~_BV(3);//0
			PORTC &= ~_BV(1);//0
			PORTB &= ~_BV(1);//0
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_4:
			//0b1001100, // 4
			PORTC &= ~_BV(0);//0
			PORTB &= ~_BV(0);//0
			PORTC |= _BV(2);//1
			PORTC |= _BV(3);//1
			PORTC &= ~_BV(1);//0
			PORTB &= ~_BV(1);//0
			PORTB |= _BV(2);//1
			break;
		case SSEG_5:
			//0b0100100, // 5
			PORTC &= ~_BV(0);//0
			PORTB &= ~_BV(0);//0
			PORTC |= _BV(2);//1
			PORTC &= ~_BV(3);//0
			PORTC &= ~_BV(1);//0
			PORTB |= _BV(1);//1
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_6:
			//0b0100000, // 6
			PORTC &= ~_BV(0);//0
			PORTB &= ~_BV(0);//0
			PORTC &= ~_BV(2);//0
			PORTC &= ~_BV(3);//0
			PORTC &= ~_BV(1);//0
			PORTB |= _BV(1);//1
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_7:
			//0b0001101, // 7
			PORTC |= _BV(0);//1
			PORTB &= ~_BV(0);//0
			PORTC |= _BV(2);//1
			PORTC |= _BV(3);//1
			PORTC &= ~_BV(1);//0
			PORTB &= ~_BV(1);//0
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_8:
			//0b0000000, // 8
			PORTC &= ~_BV(0);//0
			PORTB &= ~_BV(0);//0
			PORTC &= ~_BV(2);//0
			PORTC &= ~_BV(3);//0
			PORTC &= ~_BV(1);//0
			PORTB &= ~_BV(1);//0
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_9:
			//0b0000100, // 9
			PORTC &= ~_BV(0);//0
			PORTB &= ~_BV(0);//0
			PORTC |=  _BV(2);//1
			PORTC &= ~_BV(3);//0
			PORTC &= ~_BV(1);//0
			PORTB &= ~_BV(1);//0
			PORTB &= ~_BV(2);//0
			break;
		case SSEG_NONE:
			//0b1111111, // NONE
			PORTC |= _BV(0);//1
			PORTB |= _BV(0);//1
			PORTC |= _BV(2);//1
			PORTC |= _BV(3);//1
			PORTC |= _BV(1);//1
			PORTB |= _BV(1);//1
			PORTB |= _BV(2);//1
			break;
		case SSEG_MINUS:
			//0b1111110, // MINUS
			PORTC &= ~_BV(0);//0
			PORTB |=  _BV(0);//1
			PORTC |=  _BV(2);//1
			PORTC |=  _BV(3);//1
			PORTC |=  _BV(1);//1
			PORTB |=  _BV(1);//1
			PORTB |=  _BV(2);//1
			break;

		default:
			if( inWord < 38)
			{
				digitalWrite(10, (gSegmentDatas[inWord] >> 6) & 1);
				digitalWrite(9, (gSegmentDatas[inWord] >> 5) & 1);
				digitalWrite(A1, (gSegmentDatas[inWord] >> 4) & 1);
				digitalWrite(A3, (gSegmentDatas[inWord] >> 3) & 1);
				digitalWrite(A2, (gSegmentDatas[inWord] >> 2) & 1);
				digitalWrite(8, (gSegmentDatas[inWord] >> 1) & 1);
				digitalWrite(A0, (gSegmentDatas[inWord] >> 0) & 1);
			}
		break;

	}
	

}

void SSEG::ChangeDigit(int inDigit)
{
	//7, 8,
	switch(inDigit)
	{
	case 0:
		PORTD &= ~_BV(4);
		PORTD |= _BV(5);
		PORTD |= _BV(6);
		PORTD |= _BV(7);
		break;
	case 1:
		PORTD |= _BV(4);
		PORTD &= ~_BV(5);
		PORTD |= _BV(6);
		PORTD |= _BV(7);
		break;
	case 2:
		PORTD |= _BV(4);
		PORTD |= _BV(5);
		PORTD &= ~_BV(6);
		PORTD |= _BV(7);
		break;
	case 3:
		PORTD |= _BV(4);
		PORTD |= _BV(5);
		PORTD |= _BV(6);
		PORTD &= ~_BV(7);
		break;

	default:
		PORTD |= _BV(4);
		PORTD |= _BV(5);
		PORTD |= _BV(6);
		PORTD |= _BV(7);
		break;
	}
}

void SSEG::ShowNumber()
{
	byte aNumber = 0;
	byte a_next_digit = 0;

	if( number_displayed == 0)
	{
		
		switch(current_digit)
		{
			case 0:
				aNumber = SSEG_MINUS;
				break;
			default:
				aNumber = SSEG_NONE;
				break;
		}
	}
	else
	{
		/* code */
		switch(current_digit)
		{
			case 0:
				aNumber = number_displayed % 10;
				break;
			case 1:

				if( number_displayed < 10)
				{
					aNumber = SSEG_NONE;
				}
				else
				{
					aNumber = (number_displayed / 10) % 10;
				}

				break;
			case 2:

				if( number_displayed < 100)
				{
					aNumber = SSEG_NONE;
				}
				else
				{
					aNumber = (number_displayed / 100) % 10;
				}

				break;
			case 3:
				
				if( number_displayed < 1000)
				{
					aNumber = SSEG_NONE;
				}
				else
				{
					aNumber = (number_displayed / 1000);
				}

				break;
		}
	}

	//Change digit
	ChangeDigit(current_digit);
	
	// Show number
	Display(aNumber);

	current_digit = current_digit + 1;

	if( current_digit > 3)
	{
		current_digit = 0;
	}	
	
}

void SSEG::SetNumber(word inNumber)
{
	
	number_displayed = inNumber;
	
}
